#include <GL/glut.h>
#include "externs.h"

/***** color scheme used in this scene *****/
#define CS390_POINTS_COLOR    0.0, 0.0, 1.0       /* blue */
#define CS390_CURVE_COLOR     1.0, 0.0, 0.0       /* red */

/***** function declaration *****/
void draw_bezier_curve(int);
void draw_disk(double, double, double, double);

/***** global variable *****/
double u = 0.0;          /** this value get changed from 0.0 to 1.0 by pressing 
                         ** "left" and "right" arrows on keyboard. To control
                         ** the changing step, modify the "cs390_U_STEP" value
                         ** in "config.h" file. **/

double points_data[4][3] = {  {-80.0, -30.0, -50.0},
                                {-20.0, 25.0, 30.0},
                                {45.0, 72.0, -40.0},
                                {60.0, -60.0, 50.0}
                        };

/*
double points_data[4][3] = {  {-80.0, -30.0, 20.0},
                                {-20.0, 25.0, 2.0},
                                {45.0, 72.0, -40.0},
                                {60.0, -60.0, 50.0}
                        };

*/

/*** Your own rendering operation goes here ***/
void cs390_draw()
{
    draw_bezier_curve(4);
    /***** other rendering code goes here *****/
    glColor3f(1.0, 1.0, 0.0);
    draw_disk(1.0, 24.0, -4.0, 2);
}


/*** Your initialization goes here ***/
/*** for example, read the data from the file ***/
/*** "argc", "argv" are actual command line arguments passed in ***/
void cs390_init(int argc, char **argv)
{
}


/*** Primitivie which draws a Bezier curve and its control points ***/
void draw_bezier_curve(int n)
{
     int i;

     /* draw the control points first */
     glColor3f(CS390_POINTS_COLOR);
     glPointSize(8);
     glBegin(GL_POINTS);
     for (i = 0; i < n; i++) {
          glVertex3dv(&points_data[i][0]);
     }
     glEnd();
     /* draw the Bezier curve */
     glColor3f(CS390_CURVE_COLOR);
     glLineWidth(2);
     if(n >= 2) {
          glShadeModel(GL_FLAT);
          glEnable(GL_MAP1_VERTEX_3);
          glMap1d(GL_MAP1_VERTEX_3, 0.0, 1.0, 3, n, &points_data[0][0]);
          glBegin(GL_LINE_STRIP);
          for (i = 0; i <= 100; i++) {
               glEvalCoord1d((GLdouble) (i * 1.0) / 100);
          }
          glEnd();
     }
}

void draw_disk(double x, double y, double z, double size)
{
     glLineWidth(1);
     glPushMatrix();
          glTranslated(x, y, z);
          gluDisk(theDisk, 0.0, size, 16, 2);
     glPopMatrix();
}

